<?php namespace Dever\Helper;
class Lang
{
    private static $data = array();
    public static function get($key = 'host', $param = array())
    {
        $name = 'lang/' . Config::get('setting')['lang'];
        if (empty(self::$data[$name])) {
            self::$data[$name] = Config::get($name);
        }
        if (isset(self::$data[$name][$key])) {
            self::$data[$name][$key] = self::replace(self::$data[$name][$key], $param);
            return self::$data[$name][$key];
        }
        return $key;
    }
    private static function replace($value, &$param)
    {
        if ($param) {
            $param = self::param($param);
            foreach ($param as $k => $v) {
                self::set($value, $k, $v);
            }
        }
        return $value;
    }
    private static function param($param)
    {
        if (is_string($param)) {
            $param = array($param);
        }
        return $param;
    }
    private static function set(&$value, $k, $v)
    {
        $k = '{' . $k . '}';
        if (strpos($value, $k) !== false) {
            $value = str_replace($k, $v, $value);
        }
    }
}