<?php namespace Dever;
class Config
{
    protected static $data = array();
    public static function get($key = 'setting', $data = false)
    {
        if (empty(self::$data[$key])) {
            $path = DEVER_PROJECT_PATH . 'config' . DIRECTORY_SEPARATOR;
            $env = self::env($path);
            $file = $path . $key . '.php';
            self::$data[$key] = array();
            if (is_file($file)) {
                self::$data[$key] = include($file);
            }
        }
        if ($data) {
            self::$data[$key] = array_merge(self::$data[$key], $data);
        }
        return self::$data[$key];
    }
    protected static function env($path)
    {
        if (empty($_SERVER['DEVER_ENV_NAME'])) {
            $_SERVER['DEVER_ENV_NAME'] = 'localhost';
        }
        if (empty($_SERVER['DEVER_ENV_PATH'])) {
            $_SERVER['DEVER_ENV_PATH'] = $path . 'env' . DIRECTORY_SEPARATOR;
        }
        $file = $_SERVER['DEVER_ENV_PATH'] . $_SERVER['DEVER_ENV_NAME'] . '.php';
        if (is_file($file)) {
            return include($file);
        }
    }
}