<?php namespace Dever\Store;
use Dever\Debug;
class Base
{
    protected $read;
    protected $update;
    protected $type;
    protected static $instance;
    public static function getInstance($key, $setting, $partition)
    {
        if (isset($partition['create']) && $partition['create'] && isset($partition['database']) && $partition['database']) {
            $key .= $partition['database'];
            $setting['name'] .= '_' . $partition['database'];
        }
        if (empty(static::$instance[$key])) {
            static::$instance[$key] = new static($setting);
        }
        return static::$instance[$key];
    }
    public function __construct($setting)
    {
        if (isset($setting[0])) {
            $this->read = $this->connect($setting[0]);
            $this->update = $this->connect($setting[1]);
        } else {
            $this->read = $this->connect($setting);
            $this->update =&$this->read;
        }
    }
    protected function error($msg)
    {
        Debug::out($msg, $this->type);
    }
    protected function log($msg)
    {
        Debug::add($msg, $this->type);
    }
    public function sql(&$sql, $bind)
    {
        foreach ($bind as $k => $v) {
            if (strstr($sql, 'select') && strpos($v, ',')) {
                $v = 'in('.$v.')';
            } else {
                $v = '\'' . $v . '\'';
            }
            $sql = str_replace($k, $v, $sql);
        }
    }
}